﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ButterflyController : MonoBehaviour {
    public Sprite wingUp;
    public Sprite wingDown;
    public Sprite wingUpAlt1;
    public Sprite wingdownAlt1;
    SpriteRenderer spriteRenderer;
    bool isWingUp;
    float timeToFlap;

    public AudioClip deathSfx;

    public GameObject deathVfx;
    public GameObject deathVfxAlt1;

    // Use this for initialization
    void Start () {
        spriteRenderer = gameObject.GetComponent<SpriteRenderer>();

        if (Random.Range(0, 2) == 1)
        {
            wingUp = wingUpAlt1;
            wingDown = wingdownAlt1;
            deathVfx = deathVfxAlt1;
        }

        isWingUp = (Random.Range(0, 2) == 1);
        spriteRenderer.sprite = isWingUp ? wingUp : wingDown;
        timeToFlap = Random.Range(0f, 1f);

        ScoreManager.GainLife();
	}
	
	// Update is called once per frame
	void Update () {
        timeToFlap -= Time.deltaTime;
        if (timeToFlap <= 0)
        {
            isWingUp = !isWingUp;
            spriteRenderer.sprite = isWingUp ? wingUp : wingDown;
            timeToFlap = Random.Range(0.5f, 1.5f);
        }

        if (transform.position.x < -10) Destroy(gameObject);
    }

    void Die()
    {
        if (deathSfx != null)
        {
            AudioSource.PlayClipAtPoint(deathSfx, Vector3.zero);
        }
        if (deathVfx != null) {
            Destroy(GameObject.Instantiate(deathVfx, transform.position, transform.rotation), 2.0f);
        }

        Destroy(gameObject);
    }

    void OnDestroy()
    {
        ScoreManager.LoseLife();
    }
}
