﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class DifficultyController : MonoBehaviour {
    public SpawnController spawner;

    public float flowerChanceStart;
    public float flowerChanceIncrement;

    public float trapChanceStart;
    public float trapChanceIncrement;

    public float butterflyChanceStart;
    public float butterflyChanceIncrement;

    public float spawnRateStart;
    public float spawnRateIncrement;
    public float spawnVarianceStart;
    public float spawnVarianceIncrement;

    private float gameTime = 0;

    // Use this for initialization
    void OnEnable ()
    {
        spawner.flowerChance = flowerChanceStart;
        spawner.trapChance = trapChanceStart;
        spawner.butterflyChance = butterflyChanceStart;
        spawner.minSpawnTime = 1 / (spawnRateStart + Mathf.Epsilon) - spawnVarianceStart;
        spawner.maxSpawnTime = 1 / (spawnRateStart + Mathf.Epsilon) + spawnVarianceStart;
        gameTime = 0;
    }
	
	// Update is called once per frame
	void Update ()
    {
        gameTime += Time.deltaTime;
        spawner.flowerChance += flowerChanceIncrement * Time.deltaTime;
        spawner.trapChance += trapChanceIncrement * Time.deltaTime;
        spawner.butterflyChance += butterflyChanceIncrement * Time.deltaTime;
        spawner.minSpawnTime = 1 / (spawnRateStart + gameTime * spawnRateIncrement + Mathf.Epsilon) - spawnVarianceStart;
        spawner.maxSpawnTime = 1 / (spawnRateStart + gameTime * spawnRateIncrement + Mathf.Epsilon) + spawnVarianceStart;
    }
}
