﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class FlowerController : MonoBehaviour {
    public int value = 1;
    public float speed = -1f;

    public Sprite alive;
    public Sprite dead;

    public Sprite alt1Alive;
    public Sprite alt1Dead;

    bool killed;

    SpriteRenderer spriteRenderer;

    public AudioClip getSfx;
    public GameObject getVfx;
    public GameObject alt1GetVfx;

    // Use this for initialization
    void Start () {
        if (Random.Range(0, 2) == 1)
        {
            alive = alt1Alive;
            dead = alt1Dead;
            getVfx = alt1GetVfx;
        }

        spriteRenderer = gameObject.GetComponent<SpriteRenderer>();
        killed = false;
        spriteRenderer.sprite = alive;
	}
	
	// Update is called once per frame
	void Update ()
    {

        transform.position = new Vector2(transform.position.x + speed * Time.deltaTime, transform.position.y);

        if (transform.position.x < -10) Destroy(gameObject);
	}

    private void OnTriggerEnter2D(Collider2D collision)
    {
        if (collision.tag == "Player" && !killed)
        {
            ScoreManager.AddPoints(value);
            killed = true;
            spriteRenderer.sprite = dead;

            if (getSfx != null)
            {
                AudioSource.PlayClipAtPoint(getSfx, Vector3.zero);
            }

            if (getVfx != null)
            {
                Destroy(GameObject.Instantiate(getVfx, transform.position, transform.rotation), 2.0f);
            }
        }
    }
}
