﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class FreeButterflyController : MonoBehaviour {
    public float speed = -0.5f;

    public AddedWaveVisualiser waveVisualiser;

    public float pickupRange;

    public AudioClip getSfx;

    // Use this for initialization
    void Start () {
        waveVisualiser = GameObject.Find("WaveVisualiser").GetComponent<AddedWaveVisualiser>();
	}
	
	// Update is called once per frame
	void Update () {
        transform.position = new Vector2(transform.position.x + speed * Time.deltaTime, transform.position.y);

        if (transform.position.x > -8.8 && transform.position.x < 7.5)
        {
            float maxPickup = transform.position.y + pickupRange;
            float minPickup = transform.position.y - pickupRange;
            float waveValue = (float)waveVisualiser.GetValue(transform.position.x);
            if (waveValue > minPickup && waveValue < maxPickup)
            {
                transform.parent = waveVisualiser.transform;
                Destroy(this);
                transform.localScale = Vector2.one;

                if (getSfx != null)
                {
                    AudioSource.PlayClipAtPoint(getSfx, Vector3.zero);
                }
            }
        }
    }
}
