﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;


public class GameManager : MonoBehaviour {
    public GameObject ingameStuff;
    public GameObject mainMenu;
    public GameObject scoreScreen;

    bool inMainMenu;
    bool inGameplay;
    bool inScoreScreen;

    public List<Object> gameplayObjects;

    public AudioClip gameEndSfx;

    // Use this for initialization
    void Start () {
        ingameStuff.SetActive(false);
        mainMenu.SetActive(true);
        scoreScreen.SetActive(false);


        inMainMenu = true;
        inGameplay = false;
        inScoreScreen = false;
	}
	
	// Update is called once per frame
	void Update () {

        bool keyPressed = Input.anyKeyDown || AnyMidiKeyPress();

        if (inGameplay && ScoreManager.lives == 0)
        {
            GoToScoreScreen();
        }
        else if (inMainMenu && keyPressed)
        {
            GameStart();
        }
        else if (inScoreScreen && keyPressed)
        {
            ReturnToMenu();
        }

        if (Input.GetKeyDown(KeyCode.Escape))
        {
            Application.Quit();
        }
	}

    bool AnyMidiKeyPress()
    {

        bool value = false;
        for (int i = 0; i < 128 ; i++)
        {
            if (MidiJack.MidiMaster.GetKeyDown(i)) value = true;
        }
        return value;
    }

    void ReturnToMenu()
    {
        inGameplay = false;
        ingameStuff.SetActive(false);

        inScoreScreen = false;
        scoreScreen.SetActive(false);

        inMainMenu = true;
        mainMenu.SetActive(true);
    }

    void GoToScoreScreen()
    {
        ingameStuff.SetActive(false);
        inGameplay = false;
        scoreScreen.SetActive(true);
        inScoreScreen = true;

        foreach (Object item in gameplayObjects)
        {
            Destroy(item);
        }


        if (gameEndSfx != null)
        {
            AudioSource.PlayClipAtPoint(gameEndSfx, Vector3.zero, 1.0f);
        }
    }

    void GameStart()
    {
        mainMenu.SetActive(false);
        ingameStuff.SetActive(true);
        inGameplay = true;
        inMainMenu = false;
    }
}
