﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using System.Runtime.InteropServices;

public class MidiKnobSlider : MonoBehaviour {
	public int cc;
    public int waveNumber;
    public double maxAmp = 0.1;
    public AddedWaves waveController;

    public bool inverted { get; set; }

    Slider slider;

	// Use this for initialization
	void Start () {
        slider = gameObject.GetComponent<Slider>();
    }

    // Update is called once per frame
    void Update() {
        if (CountEndpoints() != 0)
        {
            slider.interactable = false;
            slider.value = MidiJack.MidiMaster.GetKnob(cc, 0.5f);
        } else
        {
            slider.interactable = true; 
        }
        waveController.waves[waveNumber].amp = (2 * slider.value - 1f) * maxAmp;
	}

    [DllImport("MidiJackPlugin", EntryPoint = "MidiJackCountEndpoints")]
    static extern int CountEndpoints();
}