﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SpawnController : MonoBehaviour {
    public GameObject flower;
    public GameObject trap;
    public GameObject freeButterfly;
    public GameObject butterfly;

    public float flowerChance;
    public float trapChance;
    public float butterflyChance;

    public float spawnRange;

    public float minSpawnTime = 1.5f;
    public float maxSpawnTime = 2.0f;
    float timeToNextSpawn = 0;

    public GameManager gameManager;
    public AddedWaveVisualiser waveVisualiser;

    public List<float> butterflyStartPositions;
	// Use this for initialization
	void OnEnable () {
        foreach (float x in butterflyStartPositions)
        {
            gameManager.gameplayObjects.Add(GameObject.Instantiate((Object)butterfly, new Vector2( x, (float)waveVisualiser.GetValue(x)) , transform.rotation, waveVisualiser.transform));
        }
    }
	
	// Update is called once per frame
	void Update () {
        timeToNextSpawn -= Time.deltaTime;
		if (timeToNextSpawn <= 0)
        {
            float rnjesus = Random.Range(0f, flowerChance + trapChance + butterflyChance);
            if (rnjesus < flowerChance)
            {
                gameManager.gameplayObjects.Add(GameObject.Instantiate((Object)flower, new Vector2(10, Random.Range(-spawnRange, spawnRange)), transform.rotation)); 
            }
            else if (rnjesus < flowerChance + trapChance)
            {
                gameManager.gameplayObjects.Add(GameObject.Instantiate((Object)trap, new Vector2(10, Random.Range(-spawnRange, spawnRange)), transform.rotation));
            }
            else
            {
                gameManager.gameplayObjects.Add(GameObject.Instantiate((Object)freeButterfly, new Vector2(10, Random.Range(-spawnRange, spawnRange)), transform.rotation));
            }
            timeToNextSpawn = Random.Range(minSpawnTime, maxSpawnTime);
        }
	}
}
